# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBox::Mgmt::V2018_01_01
  module Models
    #
    # The filters for showing the available skus.
    #
    class AvailableSkuRequest

      include MsRestAzure

      # @return [String] Type of the transfer. Default value: 'ImportToAzure' .
      attr_accessor :transfer_type

      # @return [String] ISO country code. Country for hardware shipment. For
      # codes check:
      # https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2#Officially_assigned_code_elements
      attr_accessor :country

      # @return [String] Location for data transfer. For locations check:
      # https://management.azure.com/subscriptions/SUBSCRIPTIONID/locations?api-version=2018-01-01
      attr_accessor :location

      # @return [Array<SkuName>] Sku Names to filter for available skus
      attr_accessor :sku_names


      #
      # Mapper for AvailableSkuRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AvailableSkuRequest',
          type: {
            name: 'Composite',
            class_name: 'AvailableSkuRequest',
            model_properties: {
              transfer_type: {
                client_side_validation: true,
                required: true,
                is_constant: true,
                serialized_name: 'transferType',
                default_value: 'ImportToAzure',
                type: {
                  name: 'String'
                }
              },
              country: {
                client_side_validation: true,
                required: true,
                serialized_name: 'country',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              sku_names: {
                client_side_validation: true,
                required: false,
                serialized_name: 'skuNames',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'SkuNameElementType',
                      type: {
                        name: 'Enum',
                        module: 'SkuName'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
