# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBox::Mgmt::V2018_01_01
  module Models
    #
    # DataBox Disk Job Details.
    #
    class DataBoxDiskJobDetails < JobDetails

      include MsRestAzure


      def initialize
        @jobDetailsType = "DataBoxDisk"
      end

      attr_accessor :jobDetailsType

      # @return [Hash{String => Integer}] User preference on what size disks
      # are needed for the job. The map is from the disk size in TB to the
      # count. Eg. {2,5} means 5 disks of 2 TB size. Key is string but will be
      # checked against an int.
      attr_accessor :preferred_disks

      # @return [Array<DataBoxDiskCopyProgress>] Copy progress per disk.
      attr_accessor :copy_progress

      # @return [Hash{String => Integer}] Contains the map of disk serial
      # number to the disk size being used for the job. Is returned only after
      # the disks are shipped to the customer.
      attr_accessor :disks_and_size_details

      # @return [String] User entered passkey for DataBox Disk job.
      attr_accessor :passkey


      #
      # Mapper for DataBoxDiskJobDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DataBoxDisk',
          type: {
            name: 'Composite',
            class_name: 'DataBoxDiskJobDetails',
            model_properties: {
              expected_data_size_in_tera_bytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'expectedDataSizeInTeraBytes',
                type: {
                  name: 'Number'
                }
              },
              job_stages: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'jobStages',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'JobStagesElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'JobStages'
                      }
                  }
                }
              },
              contact_details: {
                client_side_validation: true,
                required: true,
                serialized_name: 'contactDetails',
                type: {
                  name: 'Composite',
                  class_name: 'ContactDetails'
                }
              },
              shipping_address: {
                client_side_validation: true,
                required: true,
                serialized_name: 'shippingAddress',
                type: {
                  name: 'Composite',
                  class_name: 'ShippingAddress'
                }
              },
              delivery_package: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'deliveryPackage',
                type: {
                  name: 'Composite',
                  class_name: 'PackageShippingDetails'
                }
              },
              return_package: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'returnPackage',
                type: {
                  name: 'Composite',
                  class_name: 'PackageShippingDetails'
                }
              },
              destination_account_details: {
                client_side_validation: true,
                required: true,
                serialized_name: 'destinationAccountDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DestinationAccountDetailsElementType',
                      type: {
                        name: 'Composite',
                        polymorphic_discriminator: 'dataDestinationType',
                        uber_parent: 'DestinationAccountDetails',
                        class_name: 'DestinationAccountDetails'
                      }
                  }
                }
              },
              error_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'errorDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'JobErrorDetailsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'JobErrorDetails'
                      }
                  }
                }
              },
              preferences: {
                client_side_validation: true,
                required: false,
                serialized_name: 'preferences',
                type: {
                  name: 'Composite',
                  class_name: 'Preferences'
                }
              },
              copy_log_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'copyLogDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'CopyLogDetailsElementType',
                      type: {
                        name: 'Composite',
                        polymorphic_discriminator: 'copyLogDetailsType',
                        uber_parent: 'CopyLogDetails',
                        class_name: 'CopyLogDetails'
                      }
                  }
                }
              },
              reverse_shipment_label_sas_key: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'reverseShipmentLabelSasKey',
                type: {
                  name: 'String'
                }
              },
              chain_of_custody_sas_key: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'chainOfCustodySasKey',
                type: {
                  name: 'String'
                }
              },
              jobDetailsType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'jobDetailsType',
                type: {
                  name: 'String'
                }
              },
              preferred_disks: {
                client_side_validation: true,
                required: false,
                serialized_name: 'preferredDisks',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'NumberElementType',
                      type: {
                        name: 'Number'
                      }
                  }
                }
              },
              copy_progress: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'copyProgress',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DataBoxDiskCopyProgressElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DataBoxDiskCopyProgress'
                      }
                  }
                }
              },
              disks_and_size_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'disksAndSizeDetails',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'NumberElementType',
                      type: {
                        name: 'Number'
                      }
                  }
                }
              },
              passkey: {
                client_side_validation: true,
                required: false,
                serialized_name: 'passkey',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
