# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBox::Mgmt::V2018_01_01
  module Models
    #
    # The secrets related to a DataBoxHeavy.
    #
    class DataBoxHeavySecret

      include MsRestAzure

      # @return [String] Serial number of the assigned device.
      attr_accessor :device_serial_number

      # @return [String] Password for out of the box experience on device.
      attr_accessor :device_password

      # @return [Array<ApplianceNetworkConfiguration>] Network configuration of
      # the appliance.
      attr_accessor :network_configurations

      # @return [String] The base 64 encoded public key to authenticate with
      # the device
      attr_accessor :encoded_validation_cert_pub_key

      # @return [Array<AccountCredentialDetails>] Per account level access
      # credentials.
      attr_accessor :account_credential_details


      #
      # Mapper for DataBoxHeavySecret class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DataBoxHeavySecret',
          type: {
            name: 'Composite',
            class_name: 'DataBoxHeavySecret',
            model_properties: {
              device_serial_number: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'deviceSerialNumber',
                type: {
                  name: 'String'
                }
              },
              device_password: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'devicePassword',
                type: {
                  name: 'String'
                }
              },
              network_configurations: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'networkConfigurations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApplianceNetworkConfigurationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApplianceNetworkConfiguration'
                      }
                  }
                }
              },
              encoded_validation_cert_pub_key: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'encodedValidationCertPubKey',
                type: {
                  name: 'String'
                }
              },
              account_credential_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'accountCredentialDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AccountCredentialDetailsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AccountCredentialDetails'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
