# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBox::Mgmt::V2018_01_01
  module Models
    #
    # Job Resource.
    #
    class JobResource < Resource

      include MsRestAzure

      # @return [Boolean] Describes whether the job is cancellable or not.
      attr_accessor :is_cancellable

      # @return [Boolean] Describes whether the job is deletable or not.
      attr_accessor :is_deletable

      # @return [Boolean] Describes whether the shipping address is editable or
      # not.
      attr_accessor :is_shipping_address_editable

      # @return [StageName] Name of the stage which is in progress. Possible
      # values include: 'DeviceOrdered', 'DevicePrepared', 'Dispatched',
      # 'Delivered', 'PickedUp', 'AtAzureDC', 'DataCopy', 'Completed',
      # 'CompletedWithErrors', 'Cancelled', 'Failed_IssueReportedAtCustomer',
      # 'Failed_IssueDetectedAtAzureDC', 'Aborted'
      attr_accessor :status

      # @return [DateTime] Time at which the job was started in UTC ISO 8601
      # format.
      attr_accessor :start_time

      # @return [Error] Top level error for the job.
      attr_accessor :error

      # @return [JobDetails] Details of a job run. This field will only be sent
      # for expand details filter.
      attr_accessor :details

      # @return [String] Reason for cancellation.
      attr_accessor :cancellation_reason

      # @return [String] Name of the object.
      attr_accessor :name

      # @return [String] Id of the object.
      attr_accessor :id

      # @return [String] Type of the object.
      attr_accessor :type


      #
      # Mapper for JobResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'JobResource',
          type: {
            name: 'Composite',
            class_name: 'JobResource',
            model_properties: {
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              sku: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              is_cancellable: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.isCancellable',
                type: {
                  name: 'Boolean'
                }
              },
              is_deletable: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.isDeletable',
                type: {
                  name: 'Boolean'
                }
              },
              is_shipping_address_editable: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.isShippingAddressEditable',
                type: {
                  name: 'Boolean'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'Enum',
                  module: 'StageName'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.startTime',
                type: {
                  name: 'DateTime'
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.error',
                type: {
                  name: 'Composite',
                  class_name: 'Error'
                }
              },
              details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.details',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'jobDetailsType',
                  uber_parent: 'JobDetails',
                  class_name: 'JobDetails'
                }
              },
              cancellation_reason: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.cancellationReason',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
