# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBox::Mgmt::V2018_01_01
  module Models
    #
    # Job stages.
    #
    class JobStages

      include MsRestAzure

      # @return [StageName] Name of the job stage. Possible values include:
      # 'DeviceOrdered', 'DevicePrepared', 'Dispatched', 'Delivered',
      # 'PickedUp', 'AtAzureDC', 'DataCopy', 'Completed',
      # 'CompletedWithErrors', 'Cancelled', 'Failed_IssueReportedAtCustomer',
      # 'Failed_IssueDetectedAtAzureDC', 'Aborted'
      attr_accessor :stage_name

      # @return [String] Display name of the job stage.
      attr_accessor :display_name

      # @return [StageStatus] Status of the job stage. Possible values include:
      # 'None', 'InProgress', 'Succeeded', 'Failed', 'Cancelled', 'Cancelling',
      # 'SucceededWithErrors'
      attr_accessor :stage_status

      # @return [DateTime] Time for the job stage in UTC ISO 8601 format.
      attr_accessor :stage_time

      # @return Job Stage Details
      attr_accessor :job_stage_details

      # @return [Array<JobErrorDetails>] Error details for the stage.
      attr_accessor :error_details


      #
      # Mapper for JobStages class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'JobStages',
          type: {
            name: 'Composite',
            class_name: 'JobStages',
            model_properties: {
              stage_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'stageName',
                type: {
                  name: 'Enum',
                  module: 'StageName'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              stage_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'stageStatus',
                type: {
                  name: 'Enum',
                  module: 'StageStatus'
                }
              },
              stage_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'stageTime',
                type: {
                  name: 'DateTime'
                }
              },
              job_stage_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'jobStageDetails',
                type: {
                  name: 'Object'
                }
              },
              error_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'errorDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'JobErrorDetailsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'JobErrorDetails'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
