# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBox::Mgmt::V2018_01_01
  module Models
    #
    # Credential details of the shares in account.
    #
    class ShareCredentialDetails

      include MsRestAzure

      # @return [String] Name of the share.
      attr_accessor :share_name

      # @return [ShareDestinationFormatType] Type of the share. Possible values
      # include: 'UnknownType', 'HCS', 'BlockBlob', 'PageBlob', 'AzureFile',
      # 'ManagedDisk'
      attr_accessor :share_type

      # @return [String] User name for the share.
      attr_accessor :user_name

      # @return [String] Password for the share.
      attr_accessor :password

      # @return [Array<AccessProtocol>] Access protocols supported on the
      # device.
      attr_accessor :supported_access_protocols


      #
      # Mapper for ShareCredentialDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ShareCredentialDetails',
          type: {
            name: 'Composite',
            class_name: 'ShareCredentialDetails',
            model_properties: {
              share_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'shareName',
                type: {
                  name: 'String'
                }
              },
              share_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'shareType',
                type: {
                  name: 'Enum',
                  module: 'ShareDestinationFormatType'
                }
              },
              user_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'userName',
                type: {
                  name: 'String'
                }
              },
              password: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'password',
                type: {
                  name: 'String'
                }
              },
              supported_access_protocols: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'supportedAccessProtocols',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AccessProtocolElementType',
                      type: {
                        name: 'Enum',
                        module: 'AccessProtocol'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
